/* include gnu.gpl, (*) 2000 Micha 'malekith' Moskal <malekith@topnet.pl>. 
 * $Id: proc.c,v 1.3 2000/08/05 20:19:51 malekith Exp $ */

#include "vm.h"
#include "parser.h"
#include "proc.h"

void add_proc(frame * f, struct proc *p)
{
	hash *procs;

	procs = f->global->procs;
	
	/* do not allow duplicate procs ... */
	hash_del(procs, p->name);
	
	hash_add(procs, (var*)p);
}

/* the all purpose of this function is to allocate only 1 memory
 * block per function */
struct proc *make_proc(token *args, token *body, const char *s)
{
	byte *buf = 0, *a, *b;
	struct proc *p;
	int alen = 0, size;

	a = pack(args, 0, 0, &alen);
	size = alen + sizeof(struct proc) + strlen(s) + 1;
	
	b = pack(body, size, &buf, 0);

	p = (struct proc*)buf;
	p->body = b;
	buf += sizeof(struct proc);
	
	if (a) {
		memcpy(buf, a, alen);
		free_bc(a);
		p->args = buf;
		buf += alen;
	} else
		p->args = 0;
		
	p->name = buf;
	strcpy(p->name, s);
	
	p->cproc = 0;
	p->next = 0;

	return p;
}

void free_proc(var *p)
{
	free_bc(((struct proc*)p)->body);
}
