/* include gnu.gpl, (*) 2000 Micha 'malekith' Moskal <malekith@topnet.pl>. 
 * $Id: qq.c,v 1.7 2000/08/25 23:20:56 malekith Exp $ */

#include "vm.h"
#include "proc.h"

#define my_isalnum(a) \
	((((a) | 0x20) >= 'a' && ((a) | 0x20) <= 'z') || \
	((a) >= '0' && (a) <= '9'))
byte *bc_get_val(char *s, struct frame *f);

static char *string_rep(var *v)
{
	if (v == 0)
		return 0;
	switch (v->what) {
	case V_STRING:
		return xstrdup(v->var_string);
	case V_INT:
		return xf("%d", v->var_int);
	case V_PTR:
		return xf("*%p", v->var_ptr);
	default:
		return 0;
	}
}

static char *get_hash_dollar_exp(char **pp, char *p, frame * f)
{
	char *e, *tmp;
	int lev = 1;
	byte *code;
	vm_token t;

	e = p + 1;
	while (lev && *e) {
		if (*e == *p)
			lev++;
		else if (*p == '[' && *e == ']')
			lev--;
		else if (*p == '{' && *e == '}')
			lev--;
		e++;
	}

	tmp = xstrndup(*pp, e - *pp);
	*pp = e;
	
	code = bc_get_val(tmp, f->global);
	xfree(tmp);

	if (code == 0)
		return 0;
	unpack(&t, code);
	e = string_rep(hash_entry(&t, f->parent));
	free_bc(code);
	
	return e;
}

static char *get_dollar_exp(char **pp, frame * f)
{
	char *p, *n;

	p = *pp;
	
	/* make `blah $1` work */
	if (*p >= '0' && *p <= '9') {
		var *v;
		
		while (*p >= '0' && *p <= '9')
			p++;
		v = regexp_get(f->active_token, f, atoi(p));
		n = string_rep(v);
		free_var(v);
		*pp = p;
		return n;
	} else {
		while (my_isalnum(*p) || *p == '_')
			p++;
		if (*p == '{' || *p == '[')
			return get_hash_dollar_exp(pp, p, f);
	}
		
	n = xstrndup(*pp, p - *pp);
	*pp = p;
	p = string_rep(get_var(n, f->parent));
	xfree(n);
	return p;
}

var *c_qq(frame *f)
{
	char *s, buf[4002], *xbuf = 0, *p;
	char *typeahead = 0, *free_me = 0;
	int left;
	var *r;
	
	s = getsarg(f, "s");
	p = buf;
	left = 4000;
	
	while (typeahead || *s) {
		if (left == 0) {
			*p = 0;
			
			if (xbuf)
				xbuf = (char*)xrealloc(xbuf, 
						strlen(xbuf) + 4010);
			else {
				xbuf = (char*)xmalloc(8010);
				strcpy(xbuf, buf);
			}
			p = strchr(xbuf, 0);
			left = 4000;
		}
		
		if (typeahead) {
			if (*typeahead) {
				left--;
				*p++ = *typeahead++;
			}
			if (*typeahead == 0) {
				if (free_me)
					xfree(free_me);
				free_me = typeahead = 0;
			}
		} else if (*s == '$') {
			s++;
			free_me = typeahead = get_dollar_exp(&s, f);
		} else if (*s == '\\' && s[1] == '$') {
			left--;
			*p++ = '$';
			s += 2;
		} else {
			left--;
			*p++ = *s++;
		}
	}
	*p = 0;
	r = new_sv(0, xbuf ? xbuf : buf);
	xfree(xbuf);
	return r;
}
